# Generated by Django 5.0.6 on 2024-07-11 13:47

from django.core.validators import MinLengthValidator
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("process", "0038_remove_repository_worker_rights"),
    ]

    operations = [
        # This does not make any change in the database, since validators are only Python-side
        migrations.AlterField(
            model_name="workerconfiguration",
            name="name",
            field=models.CharField(
                max_length=250,
                validators=[MinLengthValidator(1)],
            ),
        ),
        # Give configurations with empty names some default name, "Configuration <n>"
        migrations.RunSQL(
            """
            WITH to_update (id, name) AS (
                SELECT id, 'Configuration ' || ROW_NUMBER() OVER (PARTITION BY worker_id ORDER BY id)
                FROM process_workerconfiguration
                WHERE name = ''
            )
            UPDATE process_workerconfiguration
            SET name = to_update.name
            FROM to_update
            WHERE process_workerconfiguration.id = to_update.id
            """,
            reverse_sql=migrations.RunSQL.noop,
            elidable=True,
        ),
        migrations.AddConstraint(
            model_name="workerconfiguration",
            constraint=models.CheckConstraint(
                check=~models.Q(name=""),
                name="worker_configuration_name_not_empty",
                violation_error_message="Worker configuration name cannot be empty.",
            ),
        ),
    ]
